// ====================== Color LCD  α׷ ==============================
//  : 320*240 TFT LCD(PH240320T-031-LY1Q-HX8347)
// -----------------------------------------------------------------------------
// Ʈ
#include "eng8x16.fnt"
#include "han16x16.fnt"
// ϼ ->  ȯ ̺
#include "hconvtbl.inc"

//  
#define		_WHITE		0xffff				// RRRRR GGGGGG BBBBB
#define		_BLACK		0x0000
#define		_RED		0xf800
#define		_BLUE		0x001f
#define		_GREEN		0x07e0
#define		_MAGENTA	0xf81f
#define		_GRAY		0x8410
#define		_CYAN		0x07ff
#define		_YELLOW		0xffe0

// ȭ ǥ 
#define		_SCREEN_COLUMN_SET	0			// ι ǥø ʻ(0,0) 
#define		_SCREEN_ROW_SET		1			// ι ǥø ʻ(0,0) 

#define		_SCREEN_COLUMN_X	319			// ι ǥø X ִ밪
#define		_SCREEN_COLUMN_Y	239			// ι ǥø Y ִ밪
#define		_SCREEN_ROW_X		239			// ι ǥø X ִ밪
#define		_SCREEN_ROW_Y		319			// ι ǥø Y ִ밪

// Լ 
void Clrscr(void);						// ü ȭ 
void Cleardevice(void);						// ü ȭ 
void Gotoxy(int x,int y);					// ׷ ǥ 
void Gotoxyt(int x,int y);					// ؽƮ ǥ 

void Setcolor(unsigned color);					// ڻ (_WHITE,_BLACK,..)
void Setbkcolor(unsigned color);				//  (_WHITE,_BLACK,..)
void ScreenSet(int mode,int x1,int y1,int x2,int y2);		// ǥ ȭ 

void Putch(unsigned c); 					// ڸ 
void Putchxy(int x,int y,unsigned c);				// ׷ ǥ  
void Putchxyt(int x,int y,unsigned c);				// ؽƮ ǥ  

void Puts(const char *str);					// ڿ 
void Putsxy(int x,int y,const char *str);			// ׷ ǥ ڿ 
void Putsxyt(int x,int y,const char *str);			// ؽƮ ǥ ڿ 

void Puts_f(const char flash *str);				// CODE ڿ 
void Putsxy_f(int x,int y,const char flash *str);		// ׷ ǥ CODE ڿ 
void Putsxyt_f(int x,int y,const char flash *str);		// ؽƮ ǥ CODE ڿ 

void Line(int x1,int y1,int x2,int y2);				// ׷ǥ  ׸
void Rectangle(int x1,int y1,int x2,int y2);			// ׷ ǥ ڽ ׸
void Rectanglefill(int x1,int y1,int x2,int y2);		// ä ڽ ׸
void Circle(int xx,int yy,int radius);				//  ׸
void Ellipse(int xx,int yy,int a0,int b0);			// Ÿ ׸

void Putpixelb(int x,int y,unsigned char datac,unsigned color);	// ȭ鿡 Ʈ 
void PutImage(unsigned char dbuf[],int xsize,int ysize);	// ǥ ̹ 
void Putpixel(int x,int y,unsigned color);			//  ġ Į ̿  

void Han_Conv(char *buf);					// ϼ(SRAM)  (SRAM) ȯ
void Han_Conv_f(char flash *buf);				// ϼ(FLASH) (SRAM) ȯ
void RGB_Disp(void);						// ȭ鿡 RGB  ǥ

void symmetry4(int xx,int yy,int x,int y);
void _Plotcircle(int xx,int yy,int x,int y);

void _Putch(unsigned int c);					// 1Ʈ  
void *_GetHanImage(unsigned c);					// ѱ Ʈ ε
void _memor(unsigned char *s1,unsigned char flash *s2, int len);// ѱ Ʈ 
unsigned char* _GetAscImage(int c);		        	//  Ʈ  ε

// LCD H/W 
void Clcd_Init(void);						// Golor LCD Init
void CLCD_Command_Data(int regnum,unsigned datau);		// شּҿ Register NO.+Data Write
void CLCD_Command(int regnum);					// CLCD Command Register NO. write
void CLCD_Cdata(unsigned datau);				// CLCD Command Register Data write
unsigned CLCD_GRAM_dread(void);					// CLCD GRAM Data read
void lcd_delay(unsigned short time);				// LCD ð Լ time*1ms

//  
int _screen_mode = _SCREEN_COLUMN_SET;				// ȭ ǥù 
int _screen_xmax = _SCREEN_COLUMN_X;				// θ ִ밪
int _screen_ymax = _SCREEN_COLUMN_Y;				// θ ִ밪
unsigned _screen_color = _WHITE;				// ڻ 
unsigned _screen_bkcolor = _BLACK;				//  
int _screen_curx = 0;						// X ǥ 
int _screen_cury = 0;						// Yǥ 

static unsigned char ib[32];					// ѱ  
static unsigned char ascii_fbuf[20];                            //    
static unsigned char han_conv_buf[101];				// ѱ    

// =============================== LCD ȭ  ===============================
// [μ] void
// [] 320*240
// -----------------------------------------------------------------------------
void Clrscr(void)
{
	Cleardevice();						// ȭ 
}

// =============================== LCD ȭ  ===============================
// [μ] void
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void Cleardevice(void)
{
unsigned short i,j;

	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  

	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1

	for(i = 0; i <= _screen_ymax; i++){
		PORTA = 0x00;					// BLACK
		PORTC = 0x00;
		for(j = 0; j <= _screen_xmax; j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
        	}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
	_screen_curx = _screen_cury = 0;
}

// ============================= ׷ ǥ  ==============================
// [μ] int x,int y
// Item1:  xǥ : θ ǥý(0-319) / θ ǥý(0-239)
// Item2:  yǥ : θ ǥý(0-239) / θ ǥý(0-319)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void Gotoxy(int x,int y)
{
	if(x >= 0 && x <= _screen_xmax){			// X ʰ ˻
		if(y >= 0 && y <= _screen_ymax){		// Y ʰ ˻
			_screen_curx = x;
			_screen_cury = y;
		}
	}
}

// ======================= ȭ鿡 ؽƮ ǥ  ===========================
// [μ] int x,int y
// Item1:  xǥ : θ ǥý(1-40) / θ ǥý(1-15)
// Item2:  yǥ : θ ǥý(1-15) / θ ǥý(1-40)
// []  ȭ(1,1,40,15)
//         ȭ(1,1,15,40)
// [] _screen_curx,_screen_cury
// -----------------------------------------------------------------------------
void Gotoxyt(int x,int y)
{
int x1 = (x-1) * 8,y1;

	y1 = (y-1) * 16;
	if(x1 >= 0 && x1 <= _screen_xmax){
		if(y1 >= 0 && y1 <= _screen_ymax){
			_screen_curx = x1;
			_screen_cury = y1;
		}
	}
}

// =============================== ڻ  ===============================
// [μ] unsigned color
// Item1: ڻ(_WHITE,_BLACK,..)
// -----------------------------------------------------------------------------
void Setcolor(unsigned color)
{
	_screen_color = color;					// ڻ 
}

// ===============================   ===============================
// [μ] unsigned color
// Item1: (_WHITE,_BLACK,..)
// -----------------------------------------------------------------------------
void Setbkcolor(unsigned color)
{
	_screen_bkcolor = color;				// ڻ 
}

// =========================== ǥ ȭ  ==================================
// [μ] int mode,int x1,int y1, int x2, int y2
// Item1: ũ (_SCREEN_COLUMN_SET,_SCREEN_ROW_SET)
//        _SCREEN_COLUMN_SET : ȭ  ġ : ʻ(0,0,319,239)
//        _SCREEN_ROW_SET    : ȭ  ġ : ʻ(0,0,239,320)
// Item2:  xǥ : θ ǥý(0-319) / θ ǥý(0-239)
// Item3:  yǥ : θ ǥý(0-239) / θ ǥý(0-319)
// Item4:  xǥ   : θ ǥý(0-319) / θ ǥý(0-239)
// Item5:  yǥ   : θ ǥý(0-319) / θ ǥý(0-319)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void ScreenSet(int mode,int x1,int y1,int x2,int y2)
{
	if(mode == _SCREEN_COLUMN_SET){
		CLCD_Command_Data(0x16,0x00a8);			// Memory Access Contro : MV=1, MX=0, MY=1, BGR=1 mode.
		_screen_mode = _SCREEN_COLUMN_SET;		// ȭ  ġ
		_screen_xmax = x2;				// θ ִ밪
		_screen_ymax = y2;				// θ ִ밪
	}
	else{
		CLCD_Command_Data(0x16,0x00c8);			// Memory Access Contro : MV=1, MX=1, MY=1, BGR=1 mode.
		_screen_mode = _SCREEN_ROW_SET;			// ȭ  ġ
		_screen_xmax = x2;				// θ ִ밪
		_screen_ymax = y2;				// θ ִ밪
	}
	CLCD_Command_Data(0x02,(x1>>8)&0xff);			// Column Address Start Register SC[8..15]
	CLCD_Command_Data(0x03,x1&0xff);			// Column Address Start Register SC[0..7]

	CLCD_Command_Data(0x06,(y1>>8)&0xff);			// Row Address Start Register SP[8..15]
	CLCD_Command_Data(0x07,y1&0xff);			// Row Address Start Register SP[0..7]

	CLCD_Command_Data(0x04,(x2>>8)&0xff);			// Column Address End Register EC[8..15]
	CLCD_Command_Data(0x05,x2&0xff);			// Column Address End Register EC[0..7]

	CLCD_Command_Data(0x08,(y2>>8)&0xff);			// Row Address End Register EP[8..15]
	CLCD_Command_Data(0x09,y2&0xff);			// Row Address End Register EP[0..7]
}

// ============================== ѹڸ  Ѵ. ==========================
// [μ] unsigned c
// Item1:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putch(unsigned c)
{
	_Putch(c&0xff);						// 1Ʈ ڸ ǥ
}

// ================  ׷ ǥ ѹڸ  Ѵ. ===================
// [μ] int x
//	  int y
//	  unsigned c
// Item1:    ġ(0 - 319)
// Item2:    ġ(0 - 239)
// Item3:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxy(int x,int y,unsigned c)
{
	Gotoxy(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ===================  ؽƮ ǥ ѹڸ  Ѵ. ================
// [μ] int x
//	  int y
//	  unsigned c
// Item1:  xǥ : θ ǥý(1-40) / θ ǥý(1-15)
// Item2:  yǥ : θ ǥý(1-15) / θ ǥý(1-40)
// Item3:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxyt(int x,int y,unsigned c)
{
	Gotoxyt(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ====================  Ŀ ġ  ڿ  Ѵ. ==================
// [μ] const char *str
// Item1:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Puts(const char *str)
{
unsigned char byte1st = 0,c;
unsigned datau,i = 0;

	Han_Conv((char*)str);					// ϼ  ȯ
	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
//	while((c = *str++) != 0){				// 쿡 ϼ->  
		if(byte1st){
			datau = ((unsigned)byte1st << 8) | (unsigned)c;
			_Putch(datau);				// ѱ ڸ ǥ
			byte1st = 0;                    	
		}                                       	
		else if(c & 0x80){                      	
			byte1st = c;				// ѱ Ÿ 
		}                                       	
		else{                                   	
			if(c == 0x0a){				//  ǵ
				_Putch(0x0d);           	
				_Putch(0x0a);           	
			}                               	
			else _Putch(c); 			//  ڸ ǥ
		}
	}
}

// ================  Ŀ ġ  FLASH ڿ  Ѵ. ================
// [μ] const char *str
// Item1:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Puts_f(const char flash *str)
{
unsigned char byte1st = 0,c;
unsigned datau,i = 0;

	Han_Conv_f((char flash*)str);				// ϼ  ȯ
	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
//	while((c = *str++) != 0){				// 쿡 ϼ->  
		if(byte1st){
			datau = ((unsigned)byte1st << 8) | (unsigned)c;
			_Putch(datau);				// ѱ ڸ ǥ
			byte1st = 0;                    	
		}                                       	
		else if(c & 0x80){                      	
			byte1st = c;				// ѱ Ÿ 
		}                                       	
		else{                                   	
			if(c == 0x0a){				//  ǵ
				_Putch(0x0d);           	
				_Putch(0x0a);           	
			}                               	
			else _Putch(c); 			//  ڸ ǥ
		}
	}
}

// ==================  ׷ ġ  ڿ  Ѵ. ==================
// [μ] int x
//	  int x
//	  const char *str
// Item1: Ŀ  ǥ(0 - 319)
// Item2: Ŀ  ǥ(0 - 239)
// Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxy(int x,int y,const char *str)
{
	Gotoxy(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ================  ׷ ġ FLASH ڿ  Ѵ. ===============
// [μ] int x
//	  int x
//	  const char flash *str
// Item1: Ŀ  ǥ(0 - 319)
// Item2: Ŀ  ǥ(0 - 239)
// Item3:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Putsxy_f(int x,int y,const char flash *str)
{
	Gotoxy(x,y);						// Ŀ ġ 
	Puts_f(str);						// ڿ ǥ
}

// ================  ؽƮ ġ  ڿ  Ѵ. ====================
// [μ] int x
//	  int y
//	  const char *str
// Item1:  xǥ : θ ǥý(1-40) / θ ǥý(1-15)
// Item2:  yǥ : θ ǥý(1-15) / θ ǥý(1-40)
// Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxyt(int x,int y,const char *str)
{
	Gotoxyt(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ===============  ؽƮ ġ FLASH ڿ  Ѵ. ================
// [μ] int x
//	  int y
//	  const char flash *str
// Item1:  xǥ : θ ǥý(1-40) / θ ǥý(1-15)
// Item2:  yǥ : θ ǥý(1-15) / θ ǥý(1-40)
// Item3:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Putsxyt_f(int x,int y,const char flash *str)
{
	Gotoxyt(x,y);						// Ŀ ġ 
	Puts_f(str);						// ڿ ǥ
}

// ============== ׷ LCD  ġ   ׸ ==============
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Line(int x1,int y1,int x2,int y2)
{
int i,vdx,vdy,vix,viy,vinc,plot,plotx,ploty,x = 0,y = 0;

	vdx = x2 - x1;						// vdx = x2 - x1
	vdy = y2 - y1;						// vdy = y2 - y1
	vix = abs(vdx);						// vix = |vdx|
	viy = abs(vdy); 					// vix = |vdx|
	if(vix > viy) vinc = vix;				// vinc = vix ? viy;
	else vinc = viy;

	plotx = x1;
	ploty = y1;
	Putpixel(plotx,ploty,_screen_color);
	for(i = 0; i <= vinc; i++){
		x += vix;
		y += viy;
		plot = 0;
		if(x > vinc){
			x -= vinc;
			if(vdx > 0) plotx++;
			if(vdx < 0) plotx--;
			plot = 1;
		}
		if(y > vinc){
			y -= vinc;
			if(vdy > 0) ploty++;
			if(vdy < 0) ploty--;
			plot = 1;
		}
		if(plot)Putpixel(plotx,ploty,_screen_color);
	}
	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
}

// ================================== ڽ ׸ =============================
// [μ] int x1,int y1, int x2, int y2
// Item1:  xǥ(0-319)
// Item2:  yǥ(0-219)
// Item3:  xǥ(0-319)
// Item4:  yǥ(0-219)
// Item5: ǥ (_RED,_GREEN,BLUE,_WHITE,_BLACK...)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void Rectangle(int x1,int y1,int x2,int y2)
{
int i,j;

//  μ ׸
	ScreenSet(_screen_mode,x1,y1,x2,y1);			// ǥ ȭ 
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTA = _screen_color & 0xff;				// PORTA = datau[0..7]
	PORTC = (_screen_color >> 8) & 0xff;			// PORTC = datau[8..15]
	for(i = 0; i <= (y1-y1); i++){
		for(j = 0; j <= (x2-x1); j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
	
//  μ ׸
	ScreenSet(_screen_mode,x1,y1,x1,y2);			// ǥ ȭ 
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTA = _screen_color & 0xff;				// PORTA = datau[0..7]
	PORTC = (_screen_color >> 8) & 0xff;			// PORTC = datau[8..15]
	for(i = 0; i <= (y2-y1); i++){
		for(j = 0; j <= (x1-x1); j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

// Ʒ μ ׸
	ScreenSet(_screen_mode,x1,y2,x2,y2);			// ǥ ȭ 
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTA = _screen_color & 0xff;				// PORTA = datau[0..7]
	PORTC = (_screen_color >> 8) & 0xff;			// PORTC = datau[8..15]
	for(i = 0; i <= (y2-y2); i++){
		for(j = 0; j <= (x2-x1); j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

//  μ ׸
	ScreenSet(_screen_mode,x2,y1,x2,y2);			// ǥ ȭ 
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTA = _screen_color & 0xff;				// PORTA = datau[0..7]
	PORTC = (_screen_color >> 8) & 0xff;			// PORTC = datau[8..15]
	for(i = 0; i <= (y2-y1); i++){
		for(j = 0; j <= (x2-x2); j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
}

// ============================== ä ڽ ׸ ===========================
// [μ] int x1,int y1, int x2, int y2
// Item1:  xǥ(0-319)
// Item2:  yǥ(0-219)
// Item3:  xǥ(0-319)
// Item4:  yǥ(0-219)
// Item5: ǥ (_RED,_GREEN,BLUE,_WHITE,_BLACK...)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void Rectanglefill(int x1,int y1,int x2,int y2)
{
int i,j;

	ScreenSet(_screen_mode,x1,y1,x2,y2);			// ǥ ȭ (x1,y1,x2,y2)
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTA = _screen_color & 0xff;				// PORTA = datau[0..7]
	PORTC = (_screen_color >> 8) & 0xff;			// PORTC = datau[8..15]
	for(i = 0; i <= (y2-y1); i++){
		for(j = 0; j <= (x2-x1); j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
}

// ===============================  ׸ ===================================
// [μ] int xx
//	  int yy
//	  int  radius
// Item1:  xǥ
// Item2:  yǥ
// Item3: 
// -----------------------------------------------------------------------------
void Circle(int xx,int yy,int radius)
{
int y = radius,d = 3-(y*2),x = 0;

	while(x < y){
		Putpixel(xx+x,yy+y,_screen_color);
		_Plotcircle(xx,yy,x,y);				// Ī Ŵ
		if(d < 0) d += (x*4+6);
		else{
			d += ((x-y)*4+10);
			y--;
		}
		x++;
	}
	if(x == y) Putpixel(xx+x,yy+y,_screen_color);
}

// ====================== ׸⿡ Ǵ Ī Լ ========================
void _Plotcircle(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx-y,yy+x,_screen_color);
	Putpixel(xx+y,yy-x,_screen_color);
	Putpixel(xx-y,yy-x,_screen_color);
	Putpixel(xx+y,yy+x,_screen_color);
}

// ================================== Ÿ ׸ ===============================
// [μ] int xx
//	  int yy
//	  int a0
//	  int b0
// Item1:  xǥ
// Item2:  yǥ
// Item3:  ݰ
// Item4:  ݰ
// -----------------------------------------------------------------------------
void Ellipse(int xx,int yy,int a0,int b0)
{
int x = 0,y = b0;
long a = a0,b = b0,a2 = a*a,a22 = 2*a2,b2 = b*b,b22 = 2*b2,d,dx,dy;

	d = b2-a2*b+a2/4L;
	dx=0L;
	dy=a22*b;
	while(dx < dy){
		symmetry4(xx,yy,x,y);
		if(d > 0){
			y--;
			dy-=a22;
			d-=dy;
		}
		x++;
		dx+=b22;
		d+=b2+dx;
	}
	d+=(3*(a2-b2)/2L-(dx+dy))/2L;
	while(y >= 0){
		symmetry4(xx,yy,x,y);
		if(d < 0){
			x++;
			dx+=b22;
			d+=dx;
		}
		y--;
		dy-=a22;
		d+=a2-dy;
	}
}

// ======================= Ÿ ׸⿡ Ǵ Ī Լ =====================
void symmetry4(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx+x,yy+y,_screen_color);
}

// ========================= ȭ ι 1BYTE  =======================
// [μ] int x,int y,unsigned char data,unsigned color
// Item1:  xǥ(0-319)
// Item2:  yǥ(0-219)
// Item3: ǥ (_RED,_GREEN,BLUE,_WHITE,_BLACK...)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
//        _screen_bkcolor :: (Setbkcolor())
// ------------------------------------------------------------------------------
void Putpixelb(int x,int y,unsigned char datac,unsigned color)
{
int x1,i,datai = datac;

	x1 = x+8;
	if(x1 >	_screen_xmax) x1 = _screen_xmax;		// θ ִ밪 ˻
	ScreenSet(_screen_mode,x,y,x1,y);			// ǥ ȭ 
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	for(i = 0; i <= (x1-x); i++){
		if(datai & 0x80){				// D7 == 1 -> ڻ
			PORTA = color & 0xff;			// PORTA = datau[0..7]
			PORTC = color >> 8 & 0xff;		// PORTC = datau[8..15]
		}
		else{						// D7 == 0 -> 
			PORTA = _screen_bkcolor & 0xff;		// PORTA = datau[0..7]
			PORTC = (_screen_bkcolor >> 8) & 0xff;	// PORTC = datau[8..15]
		}
		PORTG &= ~0x01;					// PORTG.0 :: CLCD_WR\ = 0
		PORTG |= 0x01;					// PORTG.0 :: CLCD_WR\ = 1
		datai = datai << 1;				// data shift << 1
	}
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1

	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

//	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
//	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
}

// ==========================  ǥ ̹ ============================
// [μ] unsigned char dbuf[],int xsize,int ysize
// Item1: ǥҵ 
// Item2: ̹ ũ(bit) X
// Item3: ̹ ũ(bit) Y
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
//        _screen_color   : ڻ(Setcolor())
//        _screen_bkcolor : (Setbkcolor())
//        _screen_curx    : Xǥ(Gotoxy())
//        _screen_cury    : Yǥ(Gotoxy())
// ------------------------------------------------------------------------------
void PutImage(unsigned char dbuf[],int xsize,int ysize)
{
int i,k,lpos,datai,xbit;
int x = _screen_curx,y = _screen_cury;
int xcnt = xsize,ycnt = ysize;

	if((x+(xsize-1)) > _screen_xmax){			// X ʰ ˻ ǥ  
		xcnt = (_screen_xmax+1) - x;
	}
	if((y+(ysize-1)) > _screen_ymax){			// Y ʰ ˻ ǥ  
		ycnt = (_screen_ymax+1) - y;
	}
	ScreenSet(_screen_mode,x,y,(x+xcnt)-1,(y+ycnt)-1);	// ǥ ȭ 
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	for(i = lpos = 0; i < ysize; i++){			// Y sizeŭ ǥ
		if((y+i) <= _screen_ymax){			// Y sizeŭ ǥ
			for(xbit = 0; xbit < xsize; ){		// X sizeŭ ǥ
				datai = (int)dbuf[lpos++];	//  
				for(k = 0; k < 8; k++,xbit++){	// 1byte ǥ
					if((x+xbit) <= _screen_xmax){// Xǥ   ǥ	
						if(datai & 0x80){// D7 == 1 -> ڻ
							PORTA = _screen_color & 0xff;// PORTA = datau[0..7]
							PORTC = _screen_color >> 8 & 0xff;// PORTC = datau[8..15]
						}
						else{		// D7 == 0 -> 
							PORTA = _screen_bkcolor & 0xff;	// PORTA = datau[0..7]
							PORTC = (_screen_bkcolor >> 8) & 0xff;// PORTC = datau[8..15]
						}
						PORTG &= ~0x01;	// PORTG.0 :: CLCD_WR\ = 0
						PORTG |= 0x01;	// PORTG.0 :: CLCD_WR\ = 1
						datai = datai << 1;// data shift << 1
					}
					
				}
			}
		}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
// ü ȭ ǥ 	
	if(_screen_mode == _SCREEN_COLUMN_SET){
		_screen_xmax = _SCREEN_COLUMN_X;		// θ ִ밪
		_screen_ymax = _SCREEN_COLUMN_Y;		// θ ִ밪
	}
	else{
		_screen_xmax = _SCREEN_ROW_X;			// θ ִ밪
		_screen_ymax = _SCREEN_ROW_Y;			// θ ִ밪
	}
// Ŀ 
	_screen_curx += xsize;					// Xǥ 
	if(_screen_curx > _screen_xmax){			// X ʰ 0
		_screen_curx = 0;
		_screen_cury += ysize;				// Yǥ 
		if(_screen_cury > _screen_ymax){		// Y ʰ ˻ ǥ  
			_screen_curx = 0;
			_screen_cury = 0;
		}
	}
	
}

// =============================== ȭ鿡   ============================
// [μ] int x,int y,unsigned color
// Item1:  xǥ(0-319)
// Item2:  yǥ(0-219)
// Item3: ǥ (_RED,_GREEN,BLUE,_WHITE,_BLACK...)
// []  ȭ(0,0,319,239)
//         ȭ(0,0,239,319)
// -----------------------------------------------------------------------------
void Putpixel(int x,int y,unsigned color)
{
	ScreenSet(_screen_mode,x,y,x,y);			// ǥ ȭ 
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTA = color & 0xff;					// PORTA = datau[0..7]
	PORTC = (color >> 8) & 0xff;				// PORTC = datau[8..15]
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1

	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

//	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
//	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
}

// ===================== ϼ ڵ带  ȯ.=========================
// [μ] char *buf
// Item1: ȯ ڿ 
//  : ȯ   -> han_conv_buf[101]
// -----------------------------------------------------------------------------
void Han_Conv(char *buf)
{
unsigned char temp[2];
int  i,j,len;
unsigned lpos,code;

	len = strlen(buf);
	for(i = j = 0; i < len; i++){
		temp[0] = buf[i];
		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
			temp[1] = buf[++i];
			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
				code = Conv_Tbl[lpos];		// Data Read
				han_conv_buf[j++] = (char)(code >> 8);
				han_conv_buf[j++] = (char)(code & 0xff);
			}
		}
		else if(temp[0] == 0xa3){
			temp[1] = buf[++i];
			han_conv_buf[j++] = 0xda;
			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
		}
		else if(temp[0] == 0xa1){
			temp[1] = buf[++i];
			if(temp[1] == 0xa1){
				han_conv_buf[j++] = 0xd9;
				han_conv_buf[j++] = 0x31;
			}
			else{
				han_conv_buf[j++] = temp[0];
				han_conv_buf[j++] = temp[1];
			}
		}
		else han_conv_buf[j++] = temp[0];
	}
	han_conv_buf[j] = 0;					// ڿ  ǥ
}

// =============== ϼ(FLASH) ڵ带 (SRAM) ȯ.==================
// [μ] char flash *buf
// Item1: ȯ ڿ  FLASH
//  : ȯ   -> han_conv_buf[101]
// -----------------------------------------------------------------------------
void Han_Conv_f(char flash *buf)
{
unsigned char temp[2];
int  i,j,len;
unsigned lpos,code;

	len = strlenf(buf);
	for(i = j = 0; i < len; i++){
		temp[0] = buf[i];
		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
			temp[1] = buf[++i];
			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
				code = Conv_Tbl[lpos];		// Data Read
				han_conv_buf[j++] = (char)(code >> 8);
				han_conv_buf[j++] = (char)(code & 0xff);
			}
		}
		else if(temp[0] == 0xa3){
			temp[1] = buf[++i];
			han_conv_buf[j++] = 0xda;
			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
		}
		else if(temp[0] == 0xa1){
			temp[1] = buf[++i];
			if(temp[1] == 0xa1){
				han_conv_buf[j++] = 0xd9;
				han_conv_buf[j++] = 0x31;
			}
			else{
				han_conv_buf[j++] = temp[0];
				han_conv_buf[j++] = temp[1];
			}
		}
		else han_conv_buf[j++] = temp[0];
	}
	han_conv_buf[j] = 0;					// ڿ  ǥ
}

// =============================== RGB ݺ ǥ ===============================
// [μ] void
// [] 320*240 ȭ鿡 50Pixel  RGBݺ ǥ
// -----------------------------------------------------------------------------
void RGB_Disp(void)
{
int i,j;
int step_y1,step_y2,step_y3,step_y4;
unsigned datau,R = 0x3f,G = 0,B = 0;

	if(_screen_mode == _SCREEN_COLUMN_SET) ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);// ǥȭ  
	else ScreenSet(_SCREEN_ROW_SET,0,0,_SCREEN_ROW_X,_SCREEN_ROW_Y);// ǥȭ  
	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0

	if(_screen_mode == _SCREEN_COLUMN_SET){			//  ȭ
		step_y1 = 48;
		step_y2 = 96;
		step_y3 = 144;
		step_y4 = 192;
//		step_y5 = 240;
	}
	else if(_screen_mode == _SCREEN_ROW_SET){		//  ȭ
		step_y1 = 64;
		step_y2 = 128;
		step_y3 = 192;
		step_y4 = 256;
//		step_y5 = 320;
	}
	for(i = 0; i <= _screen_ymax; i++){
		datau = (R << 11) + (G << 6) + B;		// datau = RRRRRR GGGGGG BBBBBB
		PORTA = datau & 0xff;				// PORTA = datau[0..7]
		PORTC = (datau >> 8) & 0xff;			// PORTC = datau[8..15]
		if(i < step_y1){				// RED
			R = 0x1f;
			G = 0x00;			
			B = 0x00;			
		}
		else if(i < step_y2){				// GREEN
			R = 0x00;
			G = 0x1f;			
			B = 0x00;			
		}
		else if(i < step_y3){				// BLUE
			R = 0x00;
			G = 0x00;			
			B = 0x1f;			
		}
		else if(i < step_y4){				// RED
			R = 0x1f;
			G = 0x00;			
			B = 0x00;			
		}
		else{						// BLUE
			R = 0x00;
			G = 0x00;			
			B = 0x1f;			
		}
		for(j = 0; j <= _screen_xmax; j++){
			PORTG &= ~0x01;				// PORTG.0 :: CLCD_WR\ = 0
			PORTG |= 0x01;				// PORTG.0 :: CLCD_WR\ = 1
        	}
	}
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
	_screen_curx = _screen_cury = 0;
}

// ========================= Ʈ     =========================
// [μ] unsigned int	c
// Item1:  
// ------------------------------------------------------------------------------
void _Putch(unsigned int c)
{
unsigned char *image;

	if(c & 0x8000){						// ѱ ڵ Ÿ
		image = _GetHanImage(c);			// ѱ  
		PutImage(image,16,16);				// image ǥ
	}
	else{							//  ڵ Ÿ
		if(c == 0x0a){
			// ü ȭ ǥ 	
			if(_screen_mode == _SCREEN_COLUMN_SET){
				_screen_xmax = _SCREEN_COLUMN_X;// θ ִ밪
				_screen_ymax = _SCREEN_COLUMN_Y;// θ ִ밪
			}
			else{
				_screen_xmax = _SCREEN_ROW_X;	// θ ִ밪
				_screen_ymax = _SCREEN_ROW_Y;	// θ ִ밪
			}
			// YĿ 
			_screen_cury += 16;			// Ŀ   
			if(_screen_cury > _screen_ymax) _screen_cury = 0;// Ŀ   ˻
		}
		else if(c == 0x0d) _screen_curx = 0;		// Carrage Return
		else{
			image = _GetAscImage(c);		//   
			PutImage(image,8,16);			// image ǥ
		}
	}
}

// ======================== ѱ Ʈ Ÿ   ======================
//  [μ] unsigned c
//  Item1: ȯ Ÿ
//   : ȯ  
// ------------------------------------------------------------------------------
void *_GetHanImage(unsigned c)
{
unsigned h, h1, h2, h3, type1, type2, type3, pos;

	static char idxtbl1[] = {				// ʼ ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16, 17, 18, 19,  0,  0,  0,
		 0,  0,  0,  0,  0,  0,  0,  0
	};
	static char idxtbl2[] = {				// ߼ ε ̺
		 0,  0,  0,  1,  2,  3,  4,  5,
		 0,  0,  6,  7,  8,  9, 10, 11,
		 0,  0, 12, 13, 14, 15, 16, 17,
		 0,  0, 18, 19, 20, 21,  0,  0
	};
	static char idxtbl3[] = {				//  ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16,  0, 17, 18, 19, 20, 21,
		22, 23, 24, 25, 26, 27,  0,  0
    };
	static char type1tbl_no[]  = {				// ߼  ʼ /ħ 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3,
		3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0
	};
	static char type1tbl_yes[] = {				// ߼  ʼ /ħ 
		5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7,
		7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5
	};
	static char type3tbl[] = {				// ߼   
		0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0,
		2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1
	};

	h1 = (c >> 10) & 0x1F;					// ʼ ڵ
	h2 = (c >> 5)  & 0x1F;					// ߼ ڵ
	h3 = c	       & 0x1F;					//  ڵ
                                        			
	h1 = idxtbl1[h1];					// ʼ ε ڵ
	h2 = idxtbl2[h2];					// ߼ ε ڵ
	h3 = idxtbl3[h3];					//  ε ڵ

	type1 = h3 ? type1tbl_yes[h2] : type1tbl_no[h2];
	type2 = ((h1 == 0 || h1 == 1 || h1 == 16) ? 0 : 1) + (h3 ? 2 : 0);
	type3 = type3tbl[h2];

	if(h1){
		h = h1-1;					// ʼ[8][19][32] -> ʼ[152][32]
		pos = type1*19;
		memcpyf(ib, HanFont1[pos+h], 32);
	}
	else memset(ib, 0, 32);
	if(h2){
		h = h2-1;
		pos = type2*21;
		_memor(ib, HanFont2[pos+h], 32);		// ߼[4][21][32] -> ߼[84][32]
	}
	if(h3){
		h = h3-1;
		pos = type3*27;
		_memor(ib, HanFont3[pos+h], 32);		// [4][27][32] -> [108][32]
	}
	return ib;
}

// ======================  ѱ Ʈ Ѵ. ==========================
//  [μ] unsigned char *s1
//	   unsigned char flash *s2
//	   int	len
//  Item1:  
//  Item2: ε 
//  Item3: 
// ------------------------------------------------------------------------------
void _memor(unsigned char *s1,unsigned char flash *s2, int len)
{
	do{	
		*s1++ |= *s2++;
	}while (--len);
}

// =======================  Ʈ  ε ===============================
//  [μ] char c
//  Item1: ȯ Ÿ
//   : ȯ  
// -----------------------------------------------------------------------------
unsigned char* _GetAscImage(int c)
{
int i;

        for(i = 0; i < 16; i++) ascii_fbuf[i] = AscFont16[c][i];
	return ascii_fbuf;
}

// ============================== TFT LCD ʱȭ ===============================
// [μ] void
// [] 320*240 TFT LCD :: 80System 16bit Bus
// -----------------------------------------------------------------------------
void Clcd_Init(void)
{
	lcd_delay(100);						// Power ON ð 
	
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Instruction Set

	PORTA=0xff;						// PORTA OUTPUT = 0xff
	DDRA=0xff;                                              // PORTA(CLCD_D[0..7] = OUTPUT MODE)
	PORTC=0xff;						// PORTC OUTPUT = 0xff
	DDRC=0xff;                                              // PORTC(CLCD_D[8..15] = OUTPUT MODE)

// ׷ LCD 
	PORTE &= 0xbf;						// PORTE.6(RST\) = 0
	lcd_delay(100);						// reset ð 
	PORTE |= 0x40;						// PORTE.6(RST\) = 1
	lcd_delay(50);						// reset ð 
	
// init_lcd_registers
//Gamma setting 
 	CLCD_Command_Data(0x0046,0x0081);			// Gamma(1)
 	CLCD_Command_Data(0x0047,0x0010);			// Gamma(2)
 	CLCD_Command_Data(0x0048,0x0001);			// Gamma(3)
	CLCD_Command_Data(0x0049,0x0004);			// Gamma(4)
	CLCD_Command_Data(0x004A,0x0010);			// Gamma(5)
	CLCD_Command_Data(0x004B,0x0076);			// Gamma(6)
	CLCD_Command_Data(0x004C,0x0037);			// Gamma(7)
	CLCD_Command_Data(0x004D,0x0067);			// Gamma(8)
	CLCD_Command_Data(0x004E,0x0007);			// Gamma(9)
	CLCD_Command_Data(0x004F,0x0014);			// Gamma(10)
	CLCD_Command_Data(0x0050,0x000A);			// Gamma(11)
	CLCD_Command_Data(0x0051,0x000E);			// Gamma(12)

//Window Setting
   	CLCD_Command_Data(0x0002,0x0000);			// Column Address2
	CLCD_Command_Data(0x0003,0x0000);			// Column Address1
	CLCD_Command_Data(0x0004,0x0000);			// Column End2
	CLCD_Command_Data(0x0005,0x00EF);			// Column End1 :: 239
	CLCD_Command_Data(0x0006,0x0000);			// Row Address Start2
	CLCD_Command_Data(0x0007,0x0000);			// Row Address Start1
	CLCD_Command_Data(0x0008,0x0001);			// Row Address End2 :: 319
	CLCD_Command_Data(0x0009,0x003F);			// Row Address End1

//Display Setting
	lcd_delay(10);						// 10ms Delay
	CLCD_Command_Data(0x01,0x0006);				// Display Mode

	CLCD_Command_Data(0x16,0x00C8);				// Memory Access Control
	CLCD_Command_Data(0x23,0x0095);				// Cycle Control 1
	CLCD_Command_Data(0x24,0x0095);				// Cycle Control 2
	CLCD_Command_Data(0x25,0x00FF);				// Cycle Control 3
	CLCD_Command_Data(0x27,0x0002);				// Display Control 2
	CLCD_Command_Data(0x28,0x0002);				// Display Control 3
	CLCD_Command_Data(0x29,0x0002);				// Display Control 4
	CLCD_Command_Data(0x2A,0x0002);				// Display Control 5
	CLCD_Command_Data(0x2C,0x0002);				// Display Control 6
	CLCD_Command_Data(0x2D,0x0002);				// Display Control 7

	CLCD_Command_Data(0x003A,0x0001);			// Cycle Control 1
	CLCD_Command_Data(0x003B,0x0001);			// Cycle Control 2
	CLCD_Command_Data(0x003C,0x00F0);			// Cycle Control 3
	CLCD_Command_Data(0x003D,0x0000);			// Cycle Control 4
	lcd_delay(20);						// 20ms Delay
	CLCD_Command_Data(0x35,0x0038);				// Display Control 9
	CLCD_Command_Data(0x36,0x0078);				// Display Control 10
	CLCD_Command_Data(0x3E,0x0038);				// Cycle Control 5
	CLCD_Command_Data(0x40,0x000F);				// Cycle Control 6
	CLCD_Command_Data(0x41,0x00F0); 			// Cycle Control 7

	CLCD_Command_Data(0x38,0x0000);				// RGB Interface Control1

// Power Setting
 	CLCD_Command_Data(0x19,0x0049);				// OCS Control1
	CLCD_Command_Data(0x93,0x000A);				// DCCLK SYNC TO CL1
	lcd_delay(10);						// 10ms Delay
	CLCD_Command_Data(0x20,0x0050);				// Power Control 06
	CLCD_Command_Data(0x1D,0x0004);				// Power Control 03
	CLCD_Command_Data(0x1E,0x0001);				// Power Control 04

	CLCD_Command_Data(0x1F,0x0008);				// Power Control 05
	CLCD_Command_Data(0x44,0x0054); 			// VCOM Control2
//	CLCD_Command_Data(0x45,0x0010);				// VCom control3 :: original value for 3.0 Volts power supply
	CLCD_Command_Data(0x45,0x000e);				// VCom control3 :: by Brain for 3.3Volts power supply
	lcd_delay(10);						// 10ms Delay
	CLCD_Command_Data(0x1C,0x0004); 			// Power Control2
	lcd_delay(20);						// 20ms Delay
	CLCD_Command_Data(0x43,0x0080);				// VCOM Control1
	lcd_delay(5);						// 5ms Delay
	CLCD_Command_Data(0x1B,0x0008);				// Power Control1
	lcd_delay(40);						// 40ms Delay
	CLCD_Command_Data(0x1B,0x0010);				//  Power Control1
	lcd_delay(40);						// 40ms Delay

//Display On Setting
	CLCD_Command_Data(0x90,0x007F);				// Display Control8
	CLCD_Command_Data(0x26,0x0004);				// Display Control1
 	lcd_delay(40);						// 40ms Delay
	CLCD_Command_Data(0x26,0x0024);				// Display Control1
	CLCD_Command_Data(0x26,0x002C);				// Display Control1
 	lcd_delay(40);						// 40ms Delay
	CLCD_Command_Data(0x26,0x003C); 			// Display Control1
  	CLCD_Command_Data(0x57,0x0002);
	CLCD_Command_Data(0x55,0x0000);
	CLCD_Command_Data(0x57,0x0000);

	ScreenSet(_SCREEN_COLUMN_SET,0,0,_SCREEN_COLUMN_X,_SCREEN_COLUMN_Y);//  ǥ ȭ 
}

// ======================= Command Register NO+Data write ====================
// [μ] int regnum,unsigned datau
// Item1: Register No.
// Item2:  
// ---------------------------------------------------------------------------
void CLCD_Command_Data(int regnum,unsigned datau)
{
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
// regnum write
	PORTE &= ~0x20;						// PORTE.5 :: CLCD RS = 0 :: Instruction Set
	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = 0;						// CLCD_D[8..15] = 0
	PORTA = regnum & 0xff;					// CLCD_D[0..7] = regnum
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

// data 16bit write
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = (datau >> 8) & 0xff;				// PORTC = datau[8..15] high byte
	PORTA = datau & 0xff;					// PORTA = datau[0..7]  low  byte
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ======================== Command Register NO. write =======================
// [μ] int regnum,unsigned datau
// Item1: Register No.
// ---------------------------------------------------------------------------
void CLCD_Command(int regnum)
{
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
// regnum write
	PORTE &= ~0x20;						// PORTE.5 :: CLCD RS = 0 :: Instruction Set
	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = 0;						// CLCD_D[8..15] = 0
	PORTA = regnum & 0xff;					// CLCD_D[0..7] = regnum
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ======================= Command Register Data write =======================
// [μ] unsigned datau
// Item1:  
// ---------------------------------------------------------------------------
void CLCD_Cdata(unsigned datau)
{
	PORTG |= 0x03;						// PORTG.0,1 :: CLCD_WR\ = RD\ = 1
// data 16bit write
	PORTE |= 0x20;						// PORTE.5 :: CLCD RS = 1 :: Data Set
	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0
	PORTG &= ~0x01;						// PORTG.0 :: CLCD_WR\ = 0

	PORTC = (datau >> 8) & 0xff;				// PORTC = datau[8..15] high byte
	PORTA = datau & 0xff;					// PORTA = datau[0..7]  low  byte
	
	PORTG |= 0x01;						// PORTG.0 :: CLCD_WR\ = 1
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1
}

// ========================== Graphic RAM Data Read ==========================
// [μ] void
// []  ġ ȼ .
// ---------------------------------------------------------------------------
unsigned CLCD_GRAM_dread(void)
{
unsigned i,datau,datau1,datau2,datau3;

	CLCD_Command(0x22);					// Set LCD register address 0x22 for make the system take GRAM data.
	PORTA=0xff;						// PORTA Է PULL UP SET
	DDRA=0x00;                                              // PORTA(CLCD_D[0..7] = INPUT MODE)
	PORTC=0xff;						// PORTA Է PULL UP SET
	DDRC=0x00;                                              // PORTC(CLCD_D[8..15] = INPUT MODE)

	PORTE |= 0x28;						// PORTE.5 :: CLCD RS = 1 :: Data Set,CLCD_164245_DIR = 1 :: RD Mode
	PORTG |= 0x03;						// PORTG.0 :: CLCD_RD\ = 1,CLCD_WR\ = 1
	PORTG &= ~0x04;						// PORTG.2 :: CLCD_CS = 0

// dummy data read
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	for(i = 0; i < 3; i++);
	datau1 = PINA & 0xff;					// CLCD_D[0..7]
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1
// data read R
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	for(i = 0; i < 3; i++);
	datau1 = PINA & 0xff;					// CLCD_D[0..7]
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1
// data read G
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	for(i = 0; i < 3; i++);
	datau2 = PINA & 0xff;					// CLCD_D[0..7]
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1
// data read B
	PORTG &= ~0x02;						// PORTG.1 :: CLCD_RD\ = 0
	for(i = 0; i < 3; i++);
	datau3 = PINA & 0xff;					// CLCD_D[0..7]
	PORTG |= 0x02;						// PORTG.1 :: CLCD_RD\ = 1

	PORTE &= ~0x08;						// CLCD_164245_DIR = 0 :: WR Mode
	PORTG |= 0x04;						// PORTG.2 :: CLCD_CS = 1

	PORTA=0xff;						// PORTA OUTPUT = 0xff
	DDRA=0xff;                                              // PORTC(CLCD_D[0..7] = OUTPUT MODE)
	PORTC=0xff;						// PORTC OUTPUT = 0xff
	DDRC=0xff;                                              // PORTC(CLCD_D[8..15] = OUTPUT MODE)
	
// RRRRR GGGGGG BBBBB
	datau = (datau1 << 8) & 0xf800;				// RED Data
	datau |= (datau2 << 3) & 0x07e0;			// GREEN Data
	datau |= (datau3 >> 3) & 0x001f;			// BLUE Data
	return(datau);
}

// ============================== LCD Delay xxxms ============================
// [μ] unsigned short time
// Item1: ð time * 1ms
// ---------------------------------------------------------------------------
void lcd_delay(unsigned short time)
{
unsigned short i,j;

  	for(i=0;i<time;i++){
 		for(j=0;j<800;j++) #asm ("nop")
	}
}

